<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Estilos: Posición y Flujo</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Estilos: Posición y Flujo</h1>
    </section>

    <section class="pt-05" data-bespoke-state='clean'>
      <h2><span class="propiedad">display</span></h2>
      <ul class="lista">
        <li>Especifica el tipo de caja que se aplica al elemento</li>
        <li>Hasta ahora hemos visto:
          <ul>
            <li><span class="valor-css">inline</span>, en linea (<span class="etiqueta">span</span>, <span class="etiqueta">strong</span>, <span class="etiqueta">em</span>...)</li>
            <li><span class="valor-css">block</span>, en bloque (<span class="etiqueta">div</span>, <span class="etiqueta">p</span>, <span class="etiqueta">h1</span>...)</li>
            <li><span class="valor-css">inline-block</span>, elemento en linea que no ignora <span class="propiedad">height</span> y <span class="propiedad">width</span></li>
          </ul>
        </li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">.en-linea</span> {
  <span class="propiedad">display:</span> <span class="valor-css">inline;</span>
}
<span class="selector">.en-bloque</span> {
  <span class="propiedad">display:</span> <span class="valor-css">block;</span>
}
<span class="selector">.en-bloque-linea</span> {
  <span class="propiedad">display:</span> <span class="valor-css">inline-block;</span>
}</code></pre>
        <iframe src="ejemplos/p16_display_block_inline.html"></iframe>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Ocultar contenido</h2>
      <ul class="lista">
        <li><span class="propiedad">display:</span> <span class="valor-css">none;</span></li>
        <li><span class="propiedad">visibility:</span> <span class="valor-css">hidden;</span> (por defecto a <span class="valor-css">visible</span>)</li>
        <li><span class="propiedad">opacity:</span> <span class="valor-css">0;</span> (<span class="valor-css">0</span> transparente a <span class="valor-css">1</span> opaco)</li>
      </ul>
      <h3>Ejemplo</h3>
      <div class="columnas-flex">
        <pre><code><span class="selector">.span-2</span> {
  <span class="propiedad">display:</span> <span class="valor-css">none;</span>
}
<span class="selector">.span-5</span> {
  <span class="propiedad">visibility:</span> <span class="valor-css">hidden;</span>
}
<span class="selector">.span-8</span> {
  <span class="propiedad">opacity:</span> <span class="valor-css">0;</span>
}</code></pre>
        <iframe class="columna-doble" src="ejemplos/p16_ocultar_contenido.html"></iframe> 
      </div>     
    </section>

    <section class="no-print pt-2" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Aplicar una misma anchura a los 4 primeros labels<br>
          *<strong>tip</strong>: los labels por defecto no responden a <span class="propiedad">height</span> y <span class="propiedad">width</span></li>
        <li>Crear unos mensajes de error que por defecto no sean visibles.<br>
          Si la clase del padre es <span class="selector">tiene-error</span>, mostrar el error
        </li>
        <li>Aplicar los estilos para que se parezca lo máximo posible al resultado</li>
      </ul>      
      <p class="text-center">
        <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio27/img/resultado.png?inline=false">Ejemplo</a>
      </p>
    </section>

    <section data-bespoke-state='clean'>
      <h1><span class="propiedad">position</span></h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">position:</span> <span class="valor-css">static;</span></h2>
      <ul class="lista">
        <li>Orden natural (por defecto)</li>
        <li>Las etiquetas se colocan según sean de bloque, en linea..</li>
      </ul>
      <h3>Ejemplo</h3>
      <pre><code><span class="selector">*</span> {
  <span class="propiedad">position:</span> <span class="valor-css">static;</span>
}</code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Establecer posición</h2>
      <ul class="lista">
        <li>Unidad de medida</li>
        <li>Valor negativo, dirección invertida</li>
      </ul>
      <div style="border: 2px solid; display:grid; grid-template-areas: 'top top' 'left right' 'bottom bottom'; padding: .2em; font-size: 3em;">
        <div style="grid-area: top;"><span class="propiedad">top</span> &#8595;</div>
        <div style="grid-area: left; text-align: left;"><span class="propiedad">left</span> &#8594;</div>
        <div style="grid-area: right; text-align: right;">&#8592; <span class="propiedad">right</span></div>
        <div style="grid-area: bottom;"><span class="propiedad">bottom</span> &#8593;</div>
      </div>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">position:</span> <span class="valor-css">relative;</span></h2>
      <ul class="lista">
        <li><span class="valor-css">relative</span>, desplazamiento en base a su posición</li>
        <li>El hueco se mantiene</li>
      </ul>
      <h3><a href="ejemplos/p16_position_relative.html" target="_blank">Ejemplo</a></h3>
      <iframe src="ejemplos/p16_position_relative.html" frameborder="1" style="border: 1px solid; height: 65%; width: 100%;"></iframe>
    </section>

    <section data-bespoke-state='clean'>
      <h2><span class="propiedad">position:</span> <span class="valor-css">absolute;</span></h2>
      <ul class="lista">
        <li><span class="valor-css">absolute</span>, desplazamiento en base al ascendente<br> <span class="valor-css">absolute</span> o <span class="etiqueta">body</span></li>
        <li>El hueco no se mantiene</li>
      </ul>
      <h3><a href="ejemplos/p16_position_absolute.html" target="_blank">Ejemplo</a></h3>
      <iframe src="ejemplos/p16_position_absolute.html" frameborder="1" style="border: 1px solid; height: 65%; width: 100%;"></iframe>

    </section>

    <section class="no-print pt-2" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>      
      <ul class="lista">
        <li>Mover los párrafos para que se parezca a la solución: 
          <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio28/index.html?inline=false">index.html</a>
        </li>
      </ul>
      <p class="text-center">
        <img style="max-height: 400px; max-width: 100%;"
         src="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio28/img/resultado.png?inline=false">
      </p>
    </section>

    <section class="pt-05" data-bespoke-state='clean'>
      <h2><span class="propiedad">position:</span> <span class="valor-css">fixed;</span></h2>
      <ul class="lista">
        <li><span class="valor-css">fixed</span>, como <span class="valor-css">absolute</span> pero se mantiene pese al scroll</li>
        <li>No mantiene el hueco</li>
      </ul>
      <h3><a href="ejemplos/p16_position_fixed.html" target="_blank">Ejemplo</a></h3>
      <iframe src="ejemplos/p16_position_fixed.html" style="border: 1px solid; height: 70%; width: 100%;"></iframe>
    </section>

    <section class="pt-05" data-bespoke-state='clean'>
      <h2><span class="propiedad">position:</span> <span class="valor-css">sticky;</span></h2>
      <ul class="lista">
        <li><span class="valor-css">sticky</span>, como <span class="valor-css">relative</span> de normal y <span class="valor-css">fixed</span> al hacer scroll</li>
        <li>Mantiene el hueco</li>
        <li>Se queda pegado hasta que se sale de su padre (contenedor)</li>
      </ul>
      <h3><a href="ejemplos/p16_position_sticky.html" target="_blank">Ejemplo</a></h3>
      <iframe src="ejemplos/p16_position_sticky.html" frameborder="1" style="border: 1px solid; height: 65%; width: 100%;"></iframe>
    </section>

    <section class="pt-2" data-bespoke-state='clean'>
      <h2><span class="propiedad">z-index</span></h2>
      <ul class="lista">
        <li>Posición en el eje Z</li>
        <li>Valores positivos y negativos</li>
        <li>Por defecto 0</li>
        <li>Si no tienen posicionamiento, valor 0</li>
        <li>Se colcan de menor a mayor, de abajo a arriba</li>
      </ul>
      <h3>Ejemplo</h3>
      <iframe src="ejemplos/p16_z-index.html" style="height: 200px; width: 450px;"></iframe>
   </section>

   <section class="no-print pt-2" data-bespoke-state='clean'>
    <h2>Ejercicio</h2>
    <ul class="lista">
      <li>Poner el <span class="etiqueta">header</span> en posición fija</li>
      <li>Poner los <span class="etiqueta">h3</span> en posición sticky</li>
    </ul>      
    <p class="text-center">
      <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio29/index.html?inline=false">Ejercicio</a>
      <a class="importante" href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio29/img/resultado.png?inline=false">Resultado</a>
    </p>
    <p class="text-center">
      <img style="max-height: 315px; max-width: 100%;"
       src="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio29/img/resultado.png?inline=false">
    </p>
  </section>
    
  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });
  </script>
</body>

</html>